
'  Explanation : VBS for PPG (Photo Plethysmography) Monitor
'  Copyright   : (C)2016,SEIKO EPSON Corp. All Rights Reserved.

'  Ref: http://homepage2.nifty.com/nonnon/Download/ScriptComTest/
'       http://homepage2.nifty.com/nonnon/Download/ExcelComTest/index.html

'Option Explicit

' Set reference to NONCOMSCK.OCX
'Private WithEvents MSComm1 As NonComSck.MSComm

Private data, dataRest, numRow, ptrCol, ptrRow, actPadNum, scanInterval, samplingDelay, numFrame, measBlink
Private useTime, padL, padH, interm, highGain, lpf, filt1, filt2
Private skipNumL, skipNumH, dataSetNumL, dataSetNumH, scanIntervalL, scanIntervalH
Private samplingDelayL, samplingDelayH, firNum
Private hH(31), hM(31), hL(31)


' Open COM port
Private Sub OpenComPort(MSComm1)

	Set args = WScript.Arguments

	' Initialize receive data row and column No.
	ptrRow = 4
	ptrCol = 3
	
	' Initialize try times
	tryTimes = 0
	
	' Get port informations
	prt = args(0)
	spd = args(1)
	pri = args(2)
	bit = args(3)
	stp = args(4)
	interm = args(5)
	highGain = args(6)
	lpf = args(7)
	filt1 = args(8)
	filt2 = args(9)
	skipNumL = args(10)
	skipNumH = args(11)
	dataSetNumL = args(12)
	dataSetNumH = args(13)
	scanIntervalL = args(14)
	scanIntervalH = args(15)
	samplingDelayL = args(16)
	samplingDelayH = args(17)
	numFrame = args(18)
	firNum = args(19)
	For i = 0 To 30
		hL(i) = args(i * 3 + 20)
		hM(i) = args(i * 3 + 21)
		hH(i) = args(i * 3 + 22)
	Next
	
	numRow = dataSetNumH * 128 + dataSetNumL
	
	' Set COM parameters
	MSComm1.Settings = spd & "," & pri & "," & bit & "," & stp
	MSComm1.CommPort = prt
	MSComm1.PortOpen = True
	
	' Initialize DTR, RTS values
	MSComm1.DTREnable = False
	MSComm1.RTSEnable = False
	MSComm1.RThreshold = 1
	
End Sub


' Close COM port
Private Sub CloseComPort(MSComm1)

	' Close COM port
	MSComm1.PortOpen = False
	Set MSComm1 = Nothing
	
End Sub


' Send data to COM port
Private Sub SendDataToCom(MSComm1)

	' Check COM port is opened or not
	If MSComm1 Is Nothing Then
		MsgBox "COM port is not opened."
		Exit Sub
	ElseIf MSComm1.PortOpen = False Then
		MsgBox "COM port is not opened."
		Exit Sub
	End If
	
	' Transmit StartCommand ans conditions to COM port.
	shex = Chr(2) & Chr(interm) & Chr(highGain) & Chr(lpf) & Chr(filt1) & Chr(filt2) & Chr(skipNumL) & Chr(skipNumH) & Chr(dataSetNumL) & Chr(dataSetNumH) & Chr(scanIntervalL) & Chr(scanIntervalH) & Chr(samplingDelayL) & Chr(samplingDelayH) & Chr(numFrame)
	
	shex = shex & Chr(firNum)
	For i = 0 To 30
		shex = shex & Chr(hL(i)) & Chr(hM(i)) & Chr(hH(i))
	Next
	
	MSComm1.Output = shex
	
End Sub


' Count SJIS-length
Function MyLen(ByVal a)
    Dim c
    c = 0
    Dim i
    For i = 0 To Len(a) - 1
        Dim k
        k = Mid(a, i + 1, 1)
        If (Asc(k) And &HFF00) = 0 Then
            c = c + 1
        Else
            c = c + 2
        End If
    Next
    MyLen = c
End Function


' Receive data from COM port
Private Sub ReceiveDataFromCom(MSComm1)

	' Define event number for OnComm
	'const comEvSend = 1
	const comEvReceive = 2
	'const comEvCTS = 3
	'const comEvDSR = 4
	'const comEvCD = 5
	'const comEvRing = 6
	'const comEvEOF = 7
	
	hexStr = ""
	dataNum = 0
	RetryTimes = 0

	Set fsoProgress = WScript.CreateObject("Scripting.FileSystemObject")
	Set fsoData = WScript.CreateObject("Scripting.FileSystemObject")
	
	Set fdData = fsoData.OpenTextFile("C:\TEMP\pmData.txt", 2, True)		' 2: over write,  8: add
	WScript.Sleep(1000)
	
	Do
		WScript.Sleep(10)
		Evt = MSComm1.GetEventParameters()
		If Ubound(Evt) >= 0 Then
Set fdTrace = fsoTrace.OpenTextFile(traceFile, 8, True)		' 2: over write,  8: add
fdTrace.WriteLine("")
fdTrace.WriteLine("Ubound(Evt)=" & Ubound(Evt) & ", Evt(0)=" & Evt(0) & ", Evt(8)=" & Evt(8) & ", RetryTimes=" & RetryTimes & ".")
fdTrace.close
			If Evt(0) = "OnComm" Then
				' Evt(8) : OnComm̃Cxgԍ(MSComm1.CommEvent)
				Select Case Evt(8)
				Case comEvReceive
					' Evt(9) : Mf[^(Bytez)
					' ByteArrayToStrŎMf[^ʏ핶ɕϊ
					' ByteArrayToHexŎMf[^HEXɕϊ
					hexStr = hexStr & MSComm1.ByteArrayToHex(Evt(9))
					dataLen = MyLen(hexStr)
					binLen = LenB(hexStr)
Set fdTrace = fsoTrace.OpenTextFile(traceFile, 8, True)		' 2: over write,  8: add
fdTrace.WriteLine("dataLen=" & dataLen & ", binLen=" & binLen & ".")
fdTrace.close
					If (dataLen Mod 4) = 0 Then
						dLen4 = dataLen / 4
						For i = 0 To (dLen4 - 1)
							str1 = Mid(hexStr, (i * 4 + 3), 2)
							str2 = Mid(hexStr, (i * 4 + 1), 2)
							valH = CInt("&H" & str1)
							valL = CInt("&H" & str2)
							val = valH * 256 + valL
							fdData.WriteLine(val)
Set fdTrace = fsoTrace.OpenTextFile(traceFile, 8, True)		' 2: over write,  8: add
fdTrace.WriteLine("Val=" & val & "  Hex=" & str1 & ", " & str2 & "  Dec=" & valH & ", " & valL & ".")
fdTrace.close
						Next
						hexStr = ""
						dataNum = dataNum + dLen4
						dataSetNum = Int(dataNum / 3 + 0.5)
						
						Set fdProgress = fsoProgress.OpenTextFile("C:\TEMP\pmProgress.txt", 2, True)		' 2: over write,  8: add
						fdProgress.WriteLine(dataSetNum)
						fdProgress.close
						
						If dataSetNum >= numRow Then
Set fdTrace = fsoTrace.OpenTextFile(traceFile, 8, True)		' 2: over write,  8: add
fdTrace.WriteLine("")
fdTrace.WriteLine("*******************************************************************************")
fdTrace.WriteLine("******                         Successful done.                          ******")
fdTrace.WriteLine("*******************************************************************************")
fdTrace.close
							Exit Sub
						End If
				Else
Set fdTrace = fsoTrace.OpenTextFile(traceFile, 8, True)		' 2: over write,  8: add
fdTrace.WriteLine("*******************************************************************************")
fdTrace.close
					End If
					
				Case Else
				End Select
			Else
				RetryTimes = RetryTimes + 1
				If RetryTimes >= 10000 Then
Set fdTrace = fsoTrace.OpenTextFile(traceFile, 8, True)		' 2: over write,  8: add
fdTrace.WriteLine("")
fdTrace.WriteLine("*******************************************************************************")
fdTrace.WriteLine("******  The trial frequency of the communication exceeded 10,000 times.  ******")
fdTrace.WriteLine("*******************************************************************************")
fdTrace.close
					Set fdProgress = fsoProgress.OpenTextFile("C:\TEMP\pmProgress.txt", 2, True)		' 2: over write,  8: add
					fdProgress.WriteLine(numRow)
					fdProgress.close
					MsgBox "The trial frequency of the communication exceeded 10000 times. "
					Exit Sub
				End If
			End If
		End If
	Loop
	
	fdData.close

End Sub


' =============================================================================

Set fsoTrace = WScript.CreateObject("Scripting.FileSystemObject")
traceFile = "C:\TEMP\pmTrace.txt"

' Clear old trace
Set fdTrace = fsoTrace.OpenTextFile(traceFile, 2, True)		' 2: over write,  8: add
fdTrace.close

' Open COM port
Set MSComm1 = CreateObject("NonComSck.MSComm")

' Start event
MSComm1.Start_EventForScript()

Call OpenComPort(MSComm1)
Call SendDataToCom(MSComm1)
Call ReceiveDataFromCom(MSComm1)
Call CloseComPort(MSComm1)

Set fsoTrace = Nothing

