/** *************************************************************************
 *
 * @file	display.h
 * @brief	This is LCD display header file for S1C17W22_W23.
 *
 * @par		Copyright:
 *			Copyright (C) SEIKO EPSON CORPORATION 2014. All rights reserved.
 *
 * @warning -
 *
 * @par		History:
 *			- 04/25/2014    1.00
 *				- First revision.
 *
 ************************************************************************* */

#ifndef DISPLAY_H__
#define DISPLAY_H__


#include "init.h"


/* --- definition --- */

#define MAX_SEG_SIZE	(unsigned char) 64		// LCD RAM max (SEG)

#define LCD_CHAR_SMALL_HEART		( 'z' + 1 )		// Small heart mark
#define LCD_CHAR_LARGE_HEART		( 'z' + 2 )		// Large heart mark

#define ORIGINAL_MARK_NUM			2				// See above

#define BATTERY_FULL	0			// index of battery full in batteryFontArray
#define BATTERY_MID	1			// index of battery middle in batteryFontArray
#define BATTERY_LOW	2			// index of battery low in batteryFontArray
#define BATTERY_NON	3			// index of battery none in batteryFontArray


// LCD Display memory of each line
static const unsigned long displayMemory[2] = {
	0x7000, 0x7001,
};


/* --- external declaration --- */
extern void clearLcdLine(unsigned char);
extern void displayChar(unsigned char, unsigned char, unsigned char);
extern void displayStr(unsigned char, unsigned char, unsigned char *);
extern void drawVertLcd(unsigned short hPos, unsigned short vData);


#endif // DUSPLAY_H__
