/****************************************************************************
 *
 * @file	ad12.c
 * @brief	This is AD12 driver program file for S1C17W23.
 *
 * @par		Copyright:
 *			Copyright (C) SEIKO EPSON CORPORATION 2016. All rights reserved.
 *
 * @warning -
 *
 * @par		History:
 *			- 05/10/2016    1.00
 *				- First revision.
 *
 ***************************************************************************/

#include "ad12.h"


/****************************************************************************
 * initAdc function.
 *
 * @brief	Initialize ADC.
 ***************************************************************************/
int initAdc(void)
{
	ADC12_0CTL	= 0x0001;			// ----.----.----.---1	MODEN=1
	ADC12_0CFG	= 0x0003;			// ----.----.----.--11	VRANGE=3(1.8~3.6V)
	ADC12_0INTF	= 0x0303;			// ----.--11.----.--11	AD0OVIF,AD1OVIF,AD0CIF,AD1CIF=1(clear)
	ADC12_0INTE	= 0x0303;			// ----.--11.----.--11	AD0OVIE,AD1OVIE,AD0CIE,AD1CIE=1(enable)

	return SUCCESS;
}

/****************************************************************************
 * startAdc function.
 *
 * @brief	Start ADC.
 ***************************************************************************/
int startAdc(void)
{
	ADC12_0CTL	= 0x0001;			// ----.----.----.--01	ADST=0 MODEN=1
	ADC12_0CTL	= 0x0003;			// ----.----.----.--11	ADST=1 MODEN=1

	return SUCCESS;
}

/****************************************************************************
 * stopAdc function.
 *
 * @brief	Stop ADC.
 ***************************************************************************/
int stopAdc(void)
{
	ADC12_0CTL	= 0x0001;			// ----.----.----.--01	ADST=0 MODEN=1

	return SUCCESS;
}

