/** *************************************************************************
 *
 * @file	osc.h
 * @brief	This is OSC header file for S1C17W22_W23.
 *
 * @par		Copyright:
 *			Copyright (C) SEIKO EPSON CORPORATION 2014. All rights reserved.
 *
 * @warning -
 *
 * @par		History:
 *			- 04/25/2014    1.00
 *				- First revision.
 *
 ************************************************************************* */

#ifndef _OSC_H
#define _OSC_H

#include "init.h"

extern  char stopOsc1(void);
extern  void startOsc1(void);
extern  char stopOsc3(void);
extern  void startOsc3(unsigned char freq);
extern  char stopIOsc(void);
extern  void startIOsc(unsigned char clk);

extern  void changeSysClkOscto1(void);
extern  void changeSysClkOscto3(unsigned char freq);
extern  void changeSysClkOsctoI(void);
extern  void changeSysClkOsctoE(void);

extern  void osc1_wait(void);


#define	OSC3_WAIT_CYCLE_1024		0		// OSC3 wait 1024 cycle
#define	OSC3_WAIT_CYCLE_512			1		// OSC3 wait 512 cycle
#define	OSC3_WAIT_CYCLE_256			2		// OSC3 wait 256 cycle
#define	OSC3_WAIT_CYCLE_128			3		// OSC3 wait 128 cycle

#define	IOSC_WAIT_CYCLE_64			0		// IOSC wait 64 cycle
#define	IOSC_WAIT_CYCLE_32			1		// IOSC wait 32 cycle
#define	IOSC_WAIT_CYCLE_16			2		// IOSC wait 16 cycle
#define	IOSC_WAIT_CYCLE_8			3		// IOSC wait 8 cycle

#define	OSC_STOP_NG					0		// Fail
#define	OSC_STOP_OK					1		// Success
#define	FOUT_CLK_DIV_RATE_1			0		// FOUT=1/1
#define	FOUT_CLK_DIV_RATE_2			1		// FOUT=1/2
#define	FOUT_CLK_DIV_RATE_4			2		// FOUT=1/4

#define	OSC_SOURCE_IOSC				0
#define	OSC_SOURCE_OSC1				1
#define	OSC_SOURCE_OSC3				2

#define	OSC_EXTOSC3_OSC3			0
#define	OSC_EXTOSC3_EXT				1

#define	OSC3_500KHZ					0
#define	OSC3_1MHZ						1
#define	OSC3_2MHZ						2
#define	OSC3_4MHZ						3

//macro
#define	SET_OSC3_WAIT_CYCLE(value)	(OSC_CTL_OSC3WT=(value))
#define	SET_IOSC_WAIT_CYCLE(value)	(OSC_CTL_IOSCWT=(value))
#define	RETURN_FOUT1_TO_P30			stopFout1(); \
 										P3_PMUX0_3_P30MUX = 0x00;



#endif
